Module ShapeForm
    ' Restrict the form to the image where it doesn't match
    ' the mask color.
    Public Sub ShapeFormToBitmap(ByVal frm As Form, ByVal mask_image As System.Drawing.Bitmap, ByVal mask_color As System.Drawing.Color)
        Dim rgn As System.Drawing.Region
        Dim rect As Rectangle
        Dim Y As Integer
        Dim X As Integer
        Dim X1 As Integer

        ' Remove the form's decorations.
        frm.ControlBox = False
        frm.Text = ""
        frm.FormBorderStyle = FormBorderStyle.None

        ' Load the mask picture.
        frm.BackgroundImage = mask_image

        ' Make the form fit the picture.
        frm.Width = mask_image.Width
        frm.Height = mask_image.Height

        ' Make a region that covers the whole image.
        rect = New Rectangle(0, 0, mask_image.Width, mask_image.Height)
        rgn = New System.Drawing.Region(rect)

        ' Examine each row of pixels.
        For Y = 0 To mask_image.Height - 1
            ' Start at the leftmost pixel.
            X = 0
            X1 = 0

            Do
                ' Move to the right until we find a pixel
                ' that is not the mask color.
                Do While X < mask_image.Width
                    If Not (mask_image.GetPixel(X, Y).Equals(mask_color)) Then Exit Do
                    X = X + 1
                Loop

                ' Exclude pixels X1 to X from the region.
                If X > X1 Then
                    rect = New Rectangle(X1, Y, X - X1, 1)
                    rgn.Exclude(rect)
                End If

                ' Skip pixels until we find one that is the
                ' mask color.
                Do While X < mask_image.Width
                    If mask_image.GetPixel(X, Y).Equals(mask_color) Then Exit Do
                    X = X + 1
                Loop
                X1 = X

                If X >= mask_image.Width Then Exit Do
            Loop
        Next Y

        ' Restrict the form to the region.
        frm.Region = rgn
    End Sub
End Module
