Imports System.Reflection

Public Class AppAttributes
    Public attCompany As String
    Public attCopyright As String
    Public attDescription As String
    Public attProduct As String
    Public attTitle As String
    Public attTrademark As String
    Public attVersion As String

    Public Sub New()
        MyBase.New()

        ' Load the data.
        Dim executing_assembly As [Assembly]
        Dim attributes() As Object
        Dim i As Integer

        ' Get the executing assembly.
        executing_assembly = [Assembly].GetExecutingAssembly()

        ' Get the assembly's attributes.
        attributes = executing_assembly.GetCustomAttributes(False)

        ' Save the values we need.
        For i = 0 To attributes.GetUpperBound(0)
            Select Case attributes(i).GetType.ToString
                Case "System.Reflection.AssemblyCompanyAttribute"
                    attCompany = CType(attributes(i), AssemblyCompanyAttribute).Company
                Case "System.Reflection.AssemblyCopyrightAttribute"
                    attCopyright = CType(attributes(i), AssemblyCopyrightAttribute).Copyright
                Case "System.Reflection.AssemblyDescriptionAttribute"
                    attDescription = CType(attributes(i), AssemblyDescriptionAttribute).Description
                Case "System.Reflection.AssemblyProductAttribute"
                    attProduct = CType(attributes(i), AssemblyProductAttribute).Product
                Case "System.Reflection.AssemblyTitleAttribute"
                    attTitle = CType(attributes(i), AssemblyTitleAttribute).Title
                Case "System.Reflection.AssemblyTrademarkAttribute"
                    attTrademark = CType(attributes(i), AssemblyTrademarkAttribute).Trademark
                Case "System.Reflection.AssemblyVersionAttribute"
                    attVersion = CType(attributes(i), AssemblyVersionAttribute).Version
            End Select
        Next i

        ' Version is different.
        attVersion = executing_assembly.GetName().Version.ToString
    End Sub
End Class
